]> git.ipfire.org Git - people/teissler/ipfire-2.x.git/blob - make.sh
Introduced access point feature.
[people/teissler/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.1" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34
35 IPFVER="full" # Which versions should be compiled? (full|devel)
36
37 # Debian specific settings
38 if [ ! -e /etc/debian_version ]; then
39 FULLPATH=`which $0`
40 else
41 if [ -x /usr/bin/realpath ]; then
42 FULLPATH=`/usr/bin/realpath $0`
43 else
44 echo "ERROR: Need to do apt-get install realpath"
45 exit 1
46 fi
47 fi
48
49 PWD=`pwd`
50 BASENAME=`basename $0`
51 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
52 LOGFILE=$BASEDIR/log/_build.preparation.log
53 export BASEDIR LOGFILE
54 DIR_CHK=$BASEDIR/cache/check
55 mkdir $BASEDIR/log/ 2>/dev/null
56
57 # Include funtions
58 . tools/make-functions
59
60 if [ -f .config ]; then
61 . .config
62 else
63 echo -e "${BOLD}No configuration found!${NORMAL}"
64 echo -ne "Do you want to create one (y/N)?"
65 read CREATE_CONFIG
66 echo ""
67 if [ "$CREATE_CONFIG" == "y" ]; then
68 make_config
69 fi
70 fi
71
72 if [ -z $EDITOR ]; then
73 for i in nano emacs vi; do
74 EDITOR=$(which $i 2>/dev/null)
75 if ! [ -z $EDITOR ]; then
76 export EDITOR=$EDITOR
77 break
78 fi
79 done
80 [ -z $EDITOR ] && exiterror "You should have installed an editor."
81 fi
82
83 prepareenv() {
84 ############################################################################
85 # #
86 # Are we running the right shell? #
87 # #
88 ############################################################################
89 if [ ! "$BASH" ]; then
90 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
91 fi
92
93 if [ -z "${BASH_VERSION}" ]; then
94 exiterror "Not running BASH shell."
95 fi
96
97
98 ############################################################################
99 # #
100 # Trap on emergency exit #
101 # #
102 ############################################################################
103 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
104
105
106 ############################################################################
107 # #
108 # Resetting our nice level #
109 # #
110 ############################################################################
111 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
112 renice $NICE $$ > /dev/null
113 if [ `nice` != "$NICE" ]; then
114 beautify message FAIL
115 exiterror "Failed to set correct nice level"
116 else
117 beautify message DONE
118 fi
119
120
121 ############################################################################
122 # #
123 # Checking if running as root user #
124 # #
125 ############################################################################
126 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
127 if [ `id -u` != 0 ]; then
128 beautify message FAIL
129 exiterror "Not building as root"
130 else
131 beautify message DONE
132 fi
133
134
135 ############################################################################
136 # #
137 # Checking for necessary temporary space #
138 # #
139 ############################################################################
140 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
141 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
142 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
143 if (( 2048000 > $BASE_ASPACE )); then
144 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
145 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
146 beautify message FAIL
147 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
148 fi
149 else
150 beautify message DONE
151 fi
152
153 ############################################################################
154 # #
155 # Building Linux From Scratch system #
156 # #
157 ############################################################################
158 # Set umask
159 umask 022
160
161 # Set LFS Directory
162 LFS=$BASEDIR/build
163
164 # Check /tools symlink
165 if [ -h /tools ]; then
166 rm -f /tools
167 fi
168 if [ ! -a /tools ]; then
169 ln -s $BASEDIR/build/tools /
170 fi
171 if [ ! -h /tools ]; then
172 exiterror "Could not create /tools symbolic link."
173 fi
174
175 # Setup environment
176 set +h
177 LC_ALL=POSIX
178 MAKETUNING="-j6"
179 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
180 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
181
182 # Make some extra directories
183 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
184 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
185 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
186 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
187
188 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
189 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
190
191 # Make all sources and proc available under lfs build
192 mount --bind /dev $BASEDIR/build/dev
193 mount --bind /dev/pts $BASEDIR/build/dev/pts
194 mount --bind /dev/shm $BASEDIR/build/dev/shm
195 mount --bind /proc $BASEDIR/build/proc
196 mount --bind /sys $BASEDIR/build/sys
197 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
198 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
199 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
200 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
201 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
202 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
203 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
204 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
205 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
206
207 # This is a temporary hack!!!
208 if [ ! -f /tools/bin/hostname ]; then
209 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
210 fi
211
212 # Run LFS static binary creation scripts one by one
213 export CCACHE_DIR=$BASEDIR/ccache
214 export CCACHE_HASHDIR=1
215
216 # Remove pre-install list of installed files in case user erase some files before rebuild
217 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
218 }
219
220 buildtoolchain() {
221 LOGFILE="$BASEDIR/log/_build.toolchain.log"
222 export LOGFILE
223 ORG_PATH=$PATH
224 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
225 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
226 lfsmake1 ccache
227 lfsmake1 binutils PASS=1
228 lfsmake1 gcc PASS=1
229 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
230 lfsmake1 linux-libc-header
231 lfsmake1 glibc
232 lfsmake1 cleanup-toolchain PASS=1
233 lfsmake1 tcl
234 lfsmake1 expect
235 lfsmake1 dejagnu
236 lfsmake1 gcc PASS=2
237 lfsmake1 binutils PASS=2
238 lfsmake1 ncurses
239 lfsmake1 bash
240 lfsmake1 bzip2
241 lfsmake1 coreutils
242 lfsmake1 diffutils
243 lfsmake1 findutils
244 lfsmake1 gawk
245 lfsmake1 gettext
246 lfsmake1 grep
247 lfsmake1 gzip
248 lfsmake1 m4
249 lfsmake1 make
250 lfsmake1 patch
251 lfsmake1 perl
252 lfsmake1 sed
253 lfsmake1 tar
254 lfsmake1 texinfo
255 lfsmake1 util-linux
256 lfsmake1 cleanup-toolchain PASS=2
257 export PATH=$ORG_PATH
258 }
259
260 buildbase() {
261 LOGFILE="$BASEDIR/log/_build.base.log"
262 export LOGFILE
263 lfsmake2 stage2
264 lfsmake2 linux-libc-header
265 lfsmake2 man-pages
266 lfsmake2 glibc
267 lfsmake2 cleanup-toolchain PASS=3
268 lfsmake2 binutils
269 lfsmake2 gcc
270 lfsmake2 berkeley
271 lfsmake2 coreutils
272 lfsmake2 iana-etc
273 lfsmake2 m4
274 lfsmake2 bison
275 lfsmake2 ncurses
276 lfsmake2 procps
277 lfsmake2 sed
278 lfsmake2 libtool
279 lfsmake2 perl
280 lfsmake2 readline
281 lfsmake2 zlib
282 lfsmake2 autoconf
283 lfsmake2 automake
284 lfsmake2 bash
285 lfsmake2 bzip2
286 lfsmake2 diffutils
287 lfsmake2 e2fsprogs
288 lfsmake2 ed
289 lfsmake2 file
290 lfsmake2 findutils
291 lfsmake2 flex
292 lfsmake2 gawk
293 lfsmake2 gettext
294 lfsmake2 grep
295 lfsmake2 groff
296 lfsmake2 gzip
297 lfsmake2 inetutils
298 lfsmake2 iproute2
299 lfsmake2 kbd
300 lfsmake2 less
301 lfsmake2 libaal
302 lfsmake2 make
303 lfsmake2 man
304 lfsmake2 mktemp
305 lfsmake2 modutils
306 lfsmake2 mtd
307 lfsmake2 net-tools
308 lfsmake2 patch
309 lfsmake2 psmisc
310 lfsmake2 reiser4progs
311 lfsmake2 shadow
312 lfsmake2 sysklogd
313 lfsmake2 sysvinit
314 lfsmake2 tar
315 lfsmake2 texinfo
316 lfsmake2 udev
317 lfsmake2 util-linux
318 lfsmake2 vim
319 lfsmake2 grub
320 }
321
322 buildipfire() {
323 LOGFILE="$BASEDIR/log/_build.ipfire.log"
324 export LOGFILE
325 ipfiremake configroot
326 ipfiremake backup
327 ipfiremake dhcp
328 ipfiremake dhcpcd
329 ipfiremake libusb
330 ipfiremake libpcap
331 ipfiremake ppp
332 ipfiremake rp-pppoe
333 ipfiremake unzip
334 ipfiremake linux SMP=1
335 ipfiremake ipp2p SMP=1
336 ipfiremake zaptel SMP=1
337 ipfiremake r8169 SMP=1
338 ipfiremake r8168 SMP=1
339 ipfiremake mcs7830 SMP=1
340 ipfiremake atl1 SMP=1
341 ipfiremake dm9601 SMP=1
342 ipfiremake kqemu SMP=1
343 ipfiremake sane KMOD=1 SMP=1
344 ipfiremake linux-fusion SMP=1
345 ipfiremake linux
346 ipfiremake ipp2p
347 ipfiremake zaptel
348 ipfiremake r8169
349 ipfiremake r8168
350 ipfiremake mcs7830
351 ipfiremake atl1
352 ipfiremake dm9601
353 ipfiremake kqemu
354 ipfiremake sane KMOD=1
355 ipfiremake linux-fusion
356 ipfiremake madwifi
357 ipfiremake pkg-config
358 ipfiremake linux-atm
359 ipfiremake cpio
360 ipfiremake klibc
361 ipfiremake mkinitcpio
362 ipfiremake udev KLIBC=1
363 ipfiremake expat
364 ipfiremake gdbm
365 ipfiremake gmp
366 ipfiremake pam
367 ipfiremake openssl
368 ipfiremake curl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libidn
372 ipfiremake libjpeg
373 ipfiremake libpng
374 ipfiremake libtiff
375 ipfiremake libart
376 ipfiremake freetype
377 ipfiremake gd
378 ipfiremake popt
379 ipfiremake pcre
380 ipfiremake slang
381 ipfiremake newt
382 ipfiremake libcap
383 ipfiremake pciutils
384 ipfiremake usbutils
385 ipfiremake libxml2
386 ipfiremake libxslt
387 ipfiremake BerkeleyDB
388 ipfiremake mysql
389 ipfiremake cyrus-sasl
390 ipfiremake openldap
391 ipfiremake apache2
392 ipfiremake php
393 ipfiremake apache2 PASS=C
394 ipfiremake arping
395 ipfiremake beep
396 ipfiremake bind
397 ipfiremake cdrtools
398 ipfiremake dnsmasq
399 ipfiremake dosfstools
400 ipfiremake squashfstools
401 ipfiremake reiserfsprogs
402 ipfiremake xfsprogs
403 ipfiremake sysfsutils
404 ipfiremake fuse
405 ipfiremake ntfs-3g
406 ipfiremake ethtool
407 ipfiremake ez-ipupdate
408 ipfiremake fcron
409 ipfiremake perl-GD
410 ipfiremake GD-Graph
411 ipfiremake GD-TextUtil
412 ipfiremake gnupg
413 ipfiremake hdparm
414 ipfiremake sdparm
415 ipfiremake mtools
416 ipfiremake initscripts
417 ipfiremake whatmask
418 ipfiremake iptables
419 ipfiremake libupnp
420 ipfiremake ipp2p IPT=1
421 ipfiremake linux-igd
422 ipfiremake ipac-ng
423 ipfiremake ipaddr
424 ipfiremake iptstate
425 ipfiremake iputils
426 ipfiremake l7-protocols
427 ipfiremake mISDN
428 ipfiremake capi4k-utils
429 ipfiremake hwdata
430 ipfiremake kudzu
431 ipfiremake logrotate
432 ipfiremake logwatch
433 ipfiremake misc-progs
434 ipfiremake nano
435 ipfiremake nasm
436 ipfiremake URI
437 ipfiremake HTML-Tagset
438 ipfiremake HTML-Parser
439 ipfiremake Compress-Zlib
440 ipfiremake Digest
441 ipfiremake Digest-SHA1
442 ipfiremake Digest-HMAC
443 ipfiremake libwww-perl
444 ipfiremake Net-DNS
445 ipfiremake Net-IPv4Addr
446 ipfiremake Net_SSLeay
447 ipfiremake IO-Stringy
448 ipfiremake Unix-Syslog
449 ipfiremake Mail-Tools
450 ipfiremake MIME-Tools
451 ipfiremake Net-Server
452 ipfiremake Convert-TNEF
453 ipfiremake Convert-UUlib
454 ipfiremake Archive-Tar
455 ipfiremake Archive-Zip
456 ipfiremake Text-Tabs+Wrap
457 ipfiremake Locale-Country
458 ipfiremake XML-Parser
459 ipfiremake glib
460 ipfiremake GeoIP
461 ipfiremake fwhits
462 ipfiremake noip_updater
463 ipfiremake ntp
464 ipfiremake openssh
465 ipfiremake openswan
466 ipfiremake rrdtool
467 ipfiremake setserial
468 ipfiremake setup
469 ipfiremake snort
470 ipfiremake oinkmaster
471 ipfiremake squid
472 ipfiremake squid-graph
473 ipfiremake squidguard
474 ipfiremake calamaris
475 ipfiremake tcpdump
476 ipfiremake traceroute
477 ipfiremake vlan
478 ipfiremake wireless
479 ipfiremake libsafe
480 ipfiremake pakfire
481 ipfiremake java
482 ipfiremake spandsp
483 ipfiremake lzo
484 ipfiremake openvpn
485 ipfiremake pammysql
486 ipfiremake cups
487 ipfiremake ghostscript
488 ipfiremake foomatic
489 ipfiremake hplip
490 ipfiremake samba
491 ipfiremake sudo
492 ipfiremake mc
493 ipfiremake wget
494 ipfiremake bridge-utils
495 ipfiremake screen
496 ipfiremake hddtemp
497 ipfiremake smartmontools
498 ipfiremake htop
499 ipfiremake postfix
500 ipfiremake fetchmail
501 ipfiremake cyrus-imapd
502 ipfiremake openmailadmin
503 ipfiremake clamav
504 ipfiremake spamassassin
505 ipfiremake amavisd
506 ipfiremake alsa
507 ipfiremake mpg123
508 ipfiremake mpfire
509 ipfiremake guardian
510 ipfiremake libid3tag
511 ipfiremake libmad
512 ipfiremake libogg
513 ipfiremake libvorbis
514 ipfiremake lame
515 ipfiremake sox
516 ipfiremake libshout
517 ipfiremake icecast
518 ipfiremake icegenerator
519 ipfiremake mpd
520 ipfiremake mpc
521 ipfiremake xvid
522 ipfiremake libmpeg2
523 ipfiremake cmake
524 ipfiremake libpri
525 ipfiremake asterisk
526 ipfiremake gnump3d
527 ipfiremake libsigc++
528 ipfiremake applejuice
529 ipfiremake ocaml
530 ipfiremake mldonkey
531 ipfiremake libtorrent
532 ipfiremake rtorrent
533 ipfiremake ipfireseeder
534 ipfiremake rsync
535 ipfiremake tcpwrapper
536 ipfiremake portmap
537 ipfiremake nfs
538 ipfiremake nmap
539 ipfiremake mbmon
540 ipfiremake ncftp
541 ipfiremake etherwake
542 ipfiremake bwm-ng
543 ipfiremake tripwire
544 ipfiremake sysstat
545 ipfiremake vsftpd
546 ipfiremake which
547 ipfiremake lsof
548 ipfiremake centerim
549 ipfiremake br2684ctl
550 ipfiremake pcmciautils
551 ipfiremake collectd
552 ipfiremake lcd4linux
553 ipfiremake neon
554 ipfiremake subversion
555 ipfiremake tcptrack
556 ipfiremake teamspeak
557 ipfiremake elinks
558 ipfiremake igmpproxy
559 ipfiremake directfb
560 ipfiremake dfb++
561 ipfiremake sdl
562 ipfiremake qemu
563 ipfiremake sane
564 ipfiremake netpbm
565 ipfiremake phpSANE
566 ipfiremake tunctl
567 ipfiremake nagios
568 ipfiremake ebtables
569 ipfiremake arptables
570 ipfiremake fontconfig
571 ipfiremake freefont
572 ipfiremake ffmpeg
573 ipfiremake videolan
574 ipfiremake vdr
575 ipfiremake w_scan
576 ipfiremake git
577 ipfiremake squidclamav
578 ipfiremake bc
579 ipfiremake wpa_supplicant
580 ipfiremake hostapd
581 }
582
583 buildinstaller() {
584 # Run installer scripts one by one
585 LOGFILE="$BASEDIR/log/_build.installer.log"
586 export LOGFILE
587 ipfiremake syslinux
588 ipfiremake as86
589 ipfiremake mbr
590 ipfiremake memtest
591 installmake linux-libc-header
592 installmake binutils
593 ipfiremake uClibc PASS=1
594 ipfiremake gcc INST=1
595 installmake uClibc PASS=2
596 installmake gcc INST=2
597 installmake uClibc PASS=3
598 installmake busybox
599 installmake udev
600 installmake slang
601 installmake newt
602 installmake gettext
603 installmake kbd
604 installmake popt
605 installmake sysvinit
606 installmake misc-progs
607 installmake libaal
608 installmake reiser4progs
609 installmake reiserfsprogs
610 installmake sysfsutils
611 installmake util-linux
612 installmake pciutils
613 installmake zlib
614 installmake mtd
615 installmake wget
616 installmake hwdata
617 installmake kudzu
618 installmake pcmciautils
619 installmake installer
620 installmake initrd
621 }
622
623 buildpackages() {
624 LOGFILE="$BASEDIR/log/_build.packages.log"
625 export LOGFILE
626 echo "... see detailed log in _build.*.log files" >> $LOGFILE
627
628 installmake strip
629
630 # Generating list of packages used
631 echo -n "Generating packages list from logs" | tee -a $LOGFILE
632 rm -f $BASEDIR/doc/packages-list
633 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
634 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
635 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
636 fi
637 done
638 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
639 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
640 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
641 rm -f $BASEDIR/doc/packages-list
642 # packages-list.txt is ready to be displayed for wiki page
643 beautify message DONE
644
645 # Create images for install
646 ipfiremake cdrom ED=full
647
648 # Check if there is a loop device for building in virtual environments
649 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
650 ipfiremake usb-stick
651 fi
652 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
653
654 ipfirepackages
655
656 # Cleanup
657 stdumount
658 rm -rf $BASEDIR/build/tmp/*
659
660 # Generating total list of files
661 echo -n "Generating files list from logs" | tee -a $LOGFILE
662 rm -f $BASEDIR/log/FILES
663 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
664 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
665 echo "##" >>$BASEDIR/log/FILES
666 echo "## `basename $i`" >>$BASEDIR/log/FILES
667 echo "##" >>$BASEDIR/log/FILES
668 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
669 fi
670 done
671 beautify message DONE
672
673 cd $PWD
674 }
675
676 ipfirepackages() {
677 ipfiremake core-updates
678 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
679 if [ -e $BASEDIR/lfs/$i ]; then
680 ipfiredist $i
681 else
682 echo -n $i
683 beautify message SKIP
684 fi
685 done
686 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
687 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
688 rm -rf $BASEDIR/build/install/packages/*
689 }
690
691 # See what we're supposed to do
692 case "$1" in
693 build)
694 clear
695 BUILDMACHINE=`uname -m`
696 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
697 #only restore on a clean disk
698 if [ ! -f log/cleanup-toolchain-2-tools ]; then
699 if [ ! -n "$PACKAGE" ]; then
700 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
701 prepareenv
702 buildtoolchain
703 else
704 PACKAGENAME=${PACKAGE%.tar.gz}
705 beautify build_stage "Packaged toolchain compilation"
706 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
707 tar zxf $PACKAGE
708 prepareenv
709 else
710 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
711 fi
712 fi
713 else
714 echo -n "Using installed toolchain" | tee -a $LOGFILE
715 beautify message SKIP
716 prepareenv
717 fi
718
719 beautify build_start
720 beautify build_stage "Building LFS"
721 buildbase
722
723 beautify build_stage "Building IPFire"
724 buildipfire
725
726 beautify build_stage "Building installer"
727 buildinstaller
728
729 beautify build_stage "Building packages"
730 buildpackages
731 beautify build_end
732 ;;
733 shell)
734 # enter a shell inside LFS chroot
735 # may be used to changed kernel settings
736 prepareenv
737 entershell
738 ;;
739 clean)
740 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
741 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
742 $LOSETUP -d $i 2>/dev/null
743 done
744 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
745 umount $i
746 done
747 stdumount
748 for i in `seq 0 7`; do
749 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
750 umount /dev/loop${i} 2>/dev/null;
751 losetup -d /dev/loop${i} 2>/dev/null;
752 fi;
753 done
754 rm -rf $BASEDIR/build
755 rm -rf $BASEDIR/cdrom
756 rm -rf $BASEDIR/packages
757 rm -rf $BASEDIR/log
758 if [ -h /tools ]; then
759 rm -f /tools
760 fi
761 beautify message DONE
762 ;;
763 downloadsrc)
764 if [ ! -d $BASEDIR/cache ]; then
765 mkdir $BASEDIR/cache
766 fi
767 mkdir -p $BASEDIR/log
768 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
769 FINISHED=0
770 cd $BASEDIR/lfs
771 for c in `seq $MAX_RETRIES`; do
772 if (( FINISHED==1 )); then
773 break
774 fi
775 FINISHED=1
776 cd $BASEDIR/lfs
777 for i in *; do
778 if [ -f "$i" -a "$i" != "Config" ]; then
779 echo -ne "Loading $i"
780 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
781 if [ $? -ne 0 ]; then
782 beautify message FAIL
783 FINISHED=0
784 else
785 if [ $c -eq 1 ]; then
786 beautify message DONE
787 fi
788 fi
789 fi
790 done
791 done
792 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
793 ERROR=0
794 for i in *; do
795 if [ -f "$i" -a "$i" != "Config" ]; then
796 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
797 if [ $? -ne 0 ]; then
798 echo -ne "MD5 difference in lfs/$i"
799 beautify message FAIL
800 ERROR=1
801 fi
802 fi
803 done
804 if [ $ERROR -eq 0 ]; then
805 echo -ne "${BOLD}all files md5sum match${NORMAL}"
806 beautify message DONE
807 else
808 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
809 beautify message FAIL
810 fi
811 cd - >/dev/null 2>&1
812 ;;
813 toolchain)
814 clear
815 prepareenv
816 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
817 buildtoolchain
818 BUILDMACHINE=`uname -m`
819 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
820 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
821 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
822 build/{bin,etc,usr/bin,usr/local} \
823 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
824 log >> $LOGFILE
825 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
826 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
827 stdumount
828 ;;
829 gettoolchain)
830 BUILDMACHINE=`uname -m`
831 # arbitrary name to be updated in case of new toolchain package upload
832 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
833 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
834 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
835 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
836 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
837 cd $BASEDIR/cache/toolchains
838 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
839 if [ $? -ne 0 ]; then
840 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
841 else
842 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
843 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
844 else
845 exiterror "$PACKAGE.md5 did not match, check downloaded package"
846 fi
847 fi
848 else
849 echo "Toolchain is already downloaded. Exiting..."
850 fi
851 ;;
852 othersrc)
853 prepareenv
854 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
855 chroot $LFS /tools/bin/env -i HOME=/root \
856 TERM=$TERM PS1='\u:\w\$ ' \
857 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
858 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
859 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
860 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
861 if [ $? -eq "0" ]; then
862 beautify message DONE
863 else
864 beautify message FAIL
865 fi
866 stdumount
867 ;;
868 git)
869 case "$2" in
870 update|up)
871 git pull
872 ;;
873 commit|ci)
874 shift 2
875 git commit $*
876
877 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
878
879 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
880 read
881 [ -z $REPLY ] && exit 0
882 for i in y Y j J; do
883 if [ "$i" == "$REPLY" ]; then
884 $0 git push
885 exit $?
886 fi
887 done
888 exiterror "\"$REPLY\" is not a valid answer."
889 ;;
890 dist)
891 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
892 ;;
893 diff|di)
894 echo -ne "Make a local diff to last revision"
895 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
896 evaluate 1
897 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
898 git diff --stat
899 ;;
900 push)
901 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
902 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
903
904 git push ${GIT_URL} master
905 ;;
906 esac
907 ;;
908 uploadsrc)
909 PWD=`pwd`
910 cd $BASEDIR/cache/
911 echo -e "Uploading cache to ftp server:"
912 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
913 for i in *; do
914 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
915 grep -q $(basename $i) /tmp/ftplist
916 if [ "$?" -ne "0" ]; then
917 echo -ne "$(basename $i)"
918 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
919 if [ "$?" -ne "0" ]; then
920 beautify message FAIL
921 fi
922 fi
923 done
924 rm -f /tmp/ftplist
925 cd $PWD
926 exit 0
927 ;;
928 upload)
929 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
930 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
931 if [ -z $FTP_ISO_PORT ]; then
932 FTP_ISO_PORT=21
933 fi
934 cat <<EOF > .ftp-commands
935 mkdir -p $FTP_ISO_PATH$SVN_REVISION
936 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
937 quit
938 EOF
939 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
940 rm -f .ftp-commands
941
942 case "$2" in
943 iso)
944 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
945
946 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
947 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
948 if [ -e "$i" ]; then
949 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
950 if [ "$?" -eq "0" ]; then
951 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
952 else
953 echo "There was an error while uploading the file $i to the ftp server."
954 exit 1
955 fi
956 fi
957 done
958 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
959 if [ "$3" = "--with-sources-cd" ]; then
960 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
961 fi
962 ;;
963 paks)
964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
965 if [ "$?" -eq "0" ]; then
966 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
967 else
968 echo -e "There was an error while uploading the packages to the ftp server."
969 exit 1
970 fi
971 ;;
972 esac
973 ;;
974 batch)
975 if [ "$2" = "--background" ]; then
976 batch_script
977 exit $?
978 fi
979 if [ `screen -ls | grep -q ipfire` ]; then
980 echo "Build is already running, sorry!"
981 exit 1
982 else
983 if [ "$2" = "--rebuild" ]; then
984 export IPFIRE_REBUILD=1
985 echo "REBUILD!"
986 else
987 export IPFIRE_REBUILD=0
988 fi
989 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
990 screen -dmS ipfire $0 batch --background
991 evaluate 1
992 exit 0
993 fi
994 ;;
995 watch)
996 watch_screen
997 ;;
998 pxe)
999 case "$2" in
1000 start)
1001 start_tftpd
1002 ;;
1003 stop)
1004 stop_tftpd
1005 ;;
1006 reload|restart)
1007 reload_tftpd
1008 ;;
1009 esac
1010 exit 0
1011 ;;
1012 lang)
1013 update_langs
1014 ;;
1015 "")
1016 clear
1017 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1018 do
1019 case $name in
1020 "IPFIRE: Downloadsrc")
1021 $0 downloadsrc
1022 ;;
1023 "IPFIRE: Build (silent)")
1024 $0 build-silent
1025 ;;
1026 "IPFIRE: Watch Build")
1027 $0 watch
1028 ;;
1029 "IPFIRE: Batch")
1030 $0 batch
1031 ;;
1032 "IPFIRE: Clean")
1033 $0 clean
1034 ;;
1035 "Help")
1036 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1037 cat doc/make.sh-usage
1038 ;;
1039 "LOG: Tail")
1040 tail -f log/_*
1041 ;;
1042 "Exit")
1043 break
1044 ;;
1045 esac
1046 done
1047 ;;
1048 config)
1049 make_config
1050 ;;
1051 *)
1052 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1053 cat doc/make.sh-usage
1054 ;;
1055 esac